% function [NextState, trial_E, O_pp, C_pp, ClusCount1, sumInC1, freqInC1]=next_state(Num, Cat, T, E, NextState2, ClusCount, sumInC, O_p, C_p, freqInC, cNumber, gammaWeight);
% 
% Simulated Annealing Next State function
%
% Num - Numerical data
% Cat - Categorical data
% X - Clustership of objects
% T = temperature
% E - Current value of cost function
% State - steps of the Metropolis algorithm
% 
% NextState - State of clustership


function [NextState, trial_E, O_ppA, O_ppC, C_pp, ClusCount1, sumInC1A, sumInC1C, freqInC1]=next_state(NumA, NumC, Cat, T, E, NextState2, ClusCount, sumInCA, sumInCC, O_pA, O_pC, C_p, freqInC, cNumber, alphaWeight, betaWeight, gammaWeight, daCount)
Data0 = NumA;
Data1 = NumC;
Data2 = Cat;
mbership = NextState2;

[Clustership, trial_E, oldCluster, newCluster, randomized2, O_ppA, O_ppC, C_pp, ClusCount1, sumInC1A, sumInC1C, freqInC1] = select_object(Data0, Data1, Data2, mbership, ClusCount, sumInCA, sumInCC, O_pA, O_pC, C_p, freqInC, cNumber, alphaWeight, betaWeight, gammaWeight);  %%%% Might not need E.  Can compute from this function after random assignment of object
delta_E = trial_E - E;
if delta_E <= 0
    NextState = Clustership;
    daCount = daCount +1
else
    R = unifrnd(0,1);
    if R < exp(-delta_E/T)
        NextState = Clustership;
         daCount = daCount +1
    else
        
        NextState = mbership;
        trial_E = E;
        [theNumA_nn, theNumA_pp] = size(NumA);
        [theNumC_nn, theNumC_pp] = size(NumC);
        [theCat_nn, theCat_pp] = size(Cat);
        ClusCount1(newCluster) = ClusCount1(newCluster) - 1;
		ClusCount1(oldCluster) = ClusCount1(oldCluster) + 1;
		for j = 1:theNumA_pp
            sumInC1A(newCluster,j) = sumInC1A(newCluster,j) - NumA(randomized2,j);
            sumInC1A(oldCluster,j) = sumInC1A(oldCluster,j) + NumA(randomized2,j);
            O_ppA(newCluster,j) = sumInC1A(newCluster,j)/ClusCount1(newCluster);
            O_ppA(oldCluster,j) = sumInC1A(oldCluster,j)/ClusCount1(oldCluster);
		end
        for j = 1:theNumC_pp
            sumInC1C(newCluster,j) = sumInC1C(newCluster,j) - NumC(randomized2,j);
            sumInC1C(oldCluster,j) = sumInC1C(oldCluster,j) + NumC(randomized2,j);
            O_ppC(newCluster,j) = sumInC1C(newCluster,j)/ClusCount1(newCluster);
            O_ppC(oldCluster,j) = sumInC1C(oldCluster,j)/ClusCount1(oldCluster);
		end
		for j = 1:theCat_pp
            Cat_jjjj = unique(Cat(:,j));
            [theCat_jjjj_nn, theCat_jjjj_pp] = size(Cat_jjjj);
		
            for z = 1:theCat_jjjj_nn
                if strcmp(Cat(randomized2,j), Cat_jjjj(z)) == 1 
                    freqInC1(newCluster,j,z) = freqInC1(newCluster,j,z) - 1;
                    freqInC1(oldCluster,j,z) = freqInC1(oldCluster,j,z) + 1;
                    [catNewMaxNum1,catNewMaxIndex1] = max(freqInC1(newCluster, j,:));
                    [catOldMaxNum1,catOldMaxIndex1] = max(freqInC1(oldCluster, j,:));
                    C_pp(newCluster,j) = Cat_jjjj(catNewMaxIndex1);
                    C_pp(oldCluster,j) = Cat_jjjj(catOldMaxIndex1);
                end
            end
		end
    end
end
    
   